Attribute VB_Name = "Services"
'********************************************************************'
'* Copyright = 5763-XA1 (C) Copyright IBM Corp 1994, 1995.          *'
'*  All rights reserved.                                            *'
'*  Licensed Material - Program property of IBM                     *'
'*  Refer to copyright instructions form number G120-2083.          *'
'********************************************************************'
'********************************************************************'
'*                                                                  *'
'* Module:                                                          *'
'*   CWBSV.H                                                        *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   It contains the declarations for the following API's:          *'
'*                                                                  *'
'*     Writing message text to a history log                        *'
'*        cwbSV_CreateMessageTextHandle()                           *'
'*        cwbSV_DeleteMessageTextHandle()                           *'
'*        cwbSV_SetMessageProduct()                                 *'
'*        cwbSV_SetMessageComponent()                               *'
'*        cwbSV_LogMessageText()                                    *'
'*                                                                  *'
'*     Writing data trace points to a trace file                    *'
'*        cwbSV_CreateTraceDataHandle()                             *'
'*        cwbSV_DeleteTraceDataHandle()                             *'
'*        cwbSV_SetTraceProduct()                                   *'
'*        cwbSV_SetTraceComponent()                                 *'
'*        cwbSV_LogTraceData()                                      *'
'*                                                                  *'
'*     Writing entry/exit trace points to a trace file              *'
'*        cwbSV_CreateTraceAPIHandle()                              *'
'*        cwbSV_DeleteTraceAPIHandle()                              *'
'*        cwbSV_SetAPIProduct()                                     *'
'*        cwbSV_SetAPIComponent()                                   *'
'*        cwbSV_LogAPIEntry()                                       *'
'*        cwbSV_LogAPIExit()                                        *'
'*        cwbSV_CreateTraceSPIHandle()                              *'
'*        cwbSV_DeleteTraceSPIHandle()                              *'
'*        cwbSV_SetSPIProduct()                                     *'
'*        cwbSV_SetSPIComponent()                                   *'
'*        cwbSV_LogSPIEntry()                                       *'
'*        cwbSV_LogSPIExit()                                        *'
'*                                                                  *'
'*     Reading service files                                        *'
'*        cwbSV_GetServiceFileName()                                *'
'*        cwbSV_OpenServiceFile()                                   *'
'*        cwbSV_CloseServiceFile()                                  *'
'*        cwbSV_ClearServiceFile()                                  *'
'*        cwbSV_GetRecordCount()                                    *'
'*        cwbSV_GetMaxRecordSize()                                  *'
'*                                                                  *'
'*     Reading service records                                      *'
'*        cwbSV_CreateServiceRecHandle()                            *'
'*        cwbSV_DeleteServiceRecHandle()                            *'
'*        cwbSV_ReadOldestRecord()                                  *'
'*        cwbSV_ReadNewestRecord()                                  *'
'*        cwbSV_ReadPrevRecord()                                    *'
'*        cwbSV_ReadNextRecord()                                    *'
'*                                                                  *'
'*     Reading service record header information                    *'
'*        cwbSV_GetProduct()                                        *'
'*        cwbSV_GetComponent()                                      *'
'*        cwbSV_GetServiceType()                                    *'
'*        cwbSV_GetDateStamp()                                      *'
'*        cwbSV_GetTimeStamp()                                      *'
'*                                                                  *'
'*     Reading history log service records                          *'
'*        cwbSV_GetMessageText()                                    *'
'*                                                                  *'
'*     Reading problem log service records                          *'
'*        cwbSV_GetProblemID()                                      *'
'*        cwbSV_GetProblemText()                                    *'
'*        cwbSV_GetProblemType()                                    *'
'*        cwbSV_GetCreatedBy()                                      *'
'*        cwbSV_GetSeverity()                                       *'
'*        cwbSV_GetProblemStatus()                                  *'
'*        cwbSV_GetFailProductID()                                  *'
'*        cwbSV_GetFailVersion()                                    *'
'*        cwbSV_GetCurrentFix()                                     *'
'*        cwbSV_GetPreviousFix()                                    *'
'*        cwbSV_GetFailPathName()                                   *'
'*        cwbSV_GetFailModule()                                     *'
'*        cwbSV_GetFailMethod()                                     *'
'*        cwbSV_GetSymptomString()                                  *'
'*        cwbSV_GetOriginSystemID()                                 *'
'*        cwbSV_GetOriginSystemIPAddr()                             *'
'*                                                                  *'
'*     Reading detail trace file service records                    *'
'*        cwbSV_GetTraceData()                                      *'
'*                                                                  *'
'*     Reading entry/exit trace file service records                *'
'*        cwbSV_GetTraceAPIID()                                     *'
'*        cwbSV_GetTraceAPIType()                                   *'
'*        cwbSV_GetTraceAPIData()                                   *'
'*        cwbSV_GetTraceSPIID()                                     *'
'*        cwbSV_GetTraceSPIType()                                   *'
'*        cwbSV_GetTraceSPIData()                                   *'
'*                                                                  *'
'*     Retrieving message text associated with error handles        *'
'*        cwbSV_CreateErrHandle()                                   *'
'*        cwbSV_DeleteErrHandle()                                   *'
'*        cwbSV_GetErrText()                                        *'
'*        cwbSV_GetErrClass()                                       *'
'*        cwbSV_GetErrTextIndexed()                                 *'
'*        cwbSV_GetErrClassIndexed()                                *'
'*        cwbSV_GetErrCount()                                       *'
'*                                                                  *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   Link with the CWB.LIB import library.                          *'
'*   This module is to be used in conjunction with CWBSV.DLL.       *'
'*                                                                  *'
'*   Distinction between API & SPI trace points:                    *'
'*   ------------------------------------------                     *'
'*     Definitions:                                                 *'
'*       - API (Application Programming Interface)                  *'
'*       - SPI (System Programming Interface)                       *'
'*                                                                  *'
'*   The recommended convention is that API entry/exit trace        *'
'*   points should be put in routines that you externalize (export) *'
'*   to your users. SPI entry/exit trace points should be used in   *'
'*   key internal (non-exported) routines that you want to trace.   *'
'*                                                                  *'
'********************************************************************'


'*------------------------------------------------------------------*'
'* TYPEDEFS:                                                        *'
'*------------------------------------------------------------------*'


'*------------------------------------------------------------------*'
'* DEFINES: for cwbSV_ServiceFileType                               *'
'*------------------------------------------------------------------*'
Public Const CWBSV_HISTORY_LOG = 0
Public Const CWBSV_PROBLEM_LOG = 1
Public Const CWBSV_DETAIL_TRACE_FILE = 2
Public Const CWBSV_ENTRY_EXIT_TRACE_FILE = 3

'*------------------------------------------------------------------*'
'* DEFINES: for cwbSV_ServiceRecType                                *'
'*------------------------------------------------------------------*'
Public Const CWBSV_MESSAGE_REC = 0
Public Const CWBSV_PROBLEM_REC = 1
Public Const CWBSV_DATA_TRACE_REC = 2
Public Const CWBSV_API_TRACE_REC = 3
Public Const CWBSV_SPI_TRACE_REC = 4

'*------------------------------------------------------------------*'
'* DEFINES: for cwbSV_EventType                                     *'
'*------------------------------------------------------------------*'
Public Const CWBSV_ENTRY_POINT = 0
Public Const CWBSV_EXIT_POINT = 1

'*------------------------------------------------------------------*'
'* DEFINES: for cwbSV_ProblemType                                   *'
'*------------------------------------------------------------------*'
Public Const CWBSV_APP_DETECTED = 0
Public Const CWBSV_USER_DETECTED = 1

'*------------------------------------------------------------------*'
'* DEFINES: for cwbSV_CreatedBy                                     *'
'*------------------------------------------------------------------*'
Public Const CWBSV_OWNER_CLIENTACCESS = "P"

'*------------------------------------------------------------------*'
'* DEFINES: for cwbSV_ProblemSeverity                               *'
'*------------------------------------------------------------------*'
Public Const CWBSV_SEV_HIGH = 1
Public Const CWBSV_SEV_MEDIUM = 2
Public Const CWBSV_SEV_LOW = 3
Public Const CWBSV_SEV_NONE = 4

'*------------------------------------------------------------------*'
'* DEFINES: for cwbSV_ProblemStatus                                 *'
'*------------------------------------------------------------------*'
Public Const CWBSV_STATUS_READY = "R"
Public Const CWBSV_STATUS_SENT = "S"

'*------------------------------------------------------------------*'
'* DEFINES: for error class                                         *'
'*------------------------------------------------------------------*'
Public Const CWBSV_CLASS_INFORMATIONAL = 0
Public Const CWBSV_CLASS_ERROR_RETRY = 1
Public Const CWBSV_CLASS_ERROR_ABORT = 2

'*------------------------------------------------------------------*'
'* DEFINES: for maximum string lengths                              *'
'*------------------------------------------------------------------*'
Public Const CWBSV_MAX_FILE_PATH = 260         '* Service file path                 *'

Public Const CWBSV_MAX_PRODUCT_ID = 10 + 1     '* Service Rec: Product ID           *'
Public Const CWBSV_MAX_COMP_ID = 10 + 1        '* Service Rec: Component ID         *'
Public Const CWBSV_MAX_DATE_VALUE = 11 + 1     '* Service Rec: Date (locale format) *'
Public Const CWBSV_MAX_TIME_VALUE = 11 + 1     '* Service Rec: Time (locale format) *'

Public Const CWBSV_MAX_PROBLEM_ID = 10 + 1     '* Problem Rec: Problem ID           *'
Public Const CWBSV_MAX_PROBLEM_TEXT = 7 + 1    '* Problem Rec: Problem text         *'
Public Const CWBSV_MAX_FAIL_PRODUCT_ID = 64 + 1 '* Problem Rec: Failing product ID   *'
Public Const CWBSV_MAX_FAIL_VERSION = 64 + 1   '* Problem Rec: Failing version      *'
Public Const CWBSV_MAX_CURRENT_FIX = 8 + 1     '* Problem Rec: Current fix level    *'
Public Const CWBSV_MAX_PREVIOUS_FIX = 8 + 1    '* Problem Rec: Previous fix level   *'
Public Const CWBSV_MAX_FAIL_PATH = 1024 + 1    '* Problem Rec: Failing path         *'
Public Const CWBSV_MAX_FAIL_MODULE = 64 + 1    '* Problem Rec: Failing module name  *'
Public Const CWBSV_MAX_FAIL_METHOD = 32 + 1    '* Problem Rec: Failing method name  *'
Public Const CWBSV_MAX_SYMPTOM_STRING = 256 + 1 '* Problem Rec: Symptom string       *'
Public Const CWBSV_MAX_ORIGIN_SYS_ID = 256 + 1 '* Problem Rec: Origin system ID     *'
Public Const CWBSV_MAX_ORIGIN_IP_ADDR = 15 + 1 '* Problem Rec: Origin IP address    *'

'*------------------------------------------------------------------*'
'* DEFINES: CWBSV.H specific return codes                           *'
'*------------------------------------------------------------------*'
Public Const CWBSV_START = CWB_LAST + 1      '* CWB_LAST defined in CWB.H *'

Public Const CWBSV_INVALID_FILE_TYPE = CWBSV_START
Public Const CWBSV_INVALID_RECORD_TYPE = CWBSV_START + 1
Public Const CWBSV_INVALID_EVENT_TYPE = CWBSV_START + 2
Public Const CWBSV_NO_ERROR_MESSAGES = CWBSV_START + 3


'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_ClearServiceFile                                         *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Clears the service file identified by the handle provided.     *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceFileHandle serviceFileHandle - input              *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_OpenServiceFile() function.                          *'
'*                                                                  *'
'*   cwbSV_ErrHandle errorHandle - output                           *'
'*     Any returned messages will be written to this object.  It    *'
'*     is created with the cwbSV_CreateErrHandle API.  The          *'
'*     messages may be retrieved through the cwbSV_GetErrText API.  *'
'*     If the parameter is set to zero, no messages will be         *'
'*     retrieved.                                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_FILE_IO_ERROR - File could not be cleared.                 *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_ClearServiceFile Lib "CWBSV" ( _
                             ByVal serviceFile As Long, _
                             errorHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_CloseServiceFile                                         *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Closes the service file identified by the handle provided.     *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceFileHandle serviceFileHandle - input              *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_OpenServiceFile() function.                          *'
'*                                                                  *'
'*   cwbSV_ErrHandle errorHandle - output                           *'
'*     Any returned messages will be written to this object.  It    *'
'*     is created with the cwbSV_CreateErrHandle API.  The          *'
'*     messages may be retrieved through the cwbSV_GetErrText API.  *'
'*     If the parameter is set to zero, no messages will be         *'
'*     retrieved.                                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_FILE_IO_ERROR - File could not be closed.                  *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_CloseServiceFile Lib "CWBSV" ( _
                             ByVal serviceFile As Long, _
                             errorHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_CreateErrHandle                                          *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function creates an error message object and returns a    *'
'*   handle to it. This error handle can be passed to Client        *'
'*   Access/400 API's that support it. If an error occurs on one    *'
'*   of these API's, the error handle can be used to retrieve the   *'
'*   error messages text associated with the API error.             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ErrHandle * errorHandle -input/output                    *'
'*       Pointer to a cwbSV_ErrHandle where the handle will be      *'
'*       returned.                                                  *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed as handle address            *'
'*   CWB_NOT_ENOUGH_MEMORY - Insufficient memory to create handle.  *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_CreateErrHandle Lib "CWBSV" ( _
                             errorHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_CreateMessageTextHandle                                  *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function creates a message text object and returns a      *'
'*   handle to it. This message handle can be used in your program  *'
'*   to write message text to the currently active history log.     *'
'*   The message text is supplied in a buffer passed on the         *'
'*   cwbSV_LogMessageText() call.                                   *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   char * productID - input                                       *'
'*       Points to a null-terminated string that contains a         *'
'*       product identifier to be used on this message entry.       *'
'*       Parameter is optional, if null, no productID is set.       *'
'*       NOTE: A maximum of CWBSV_MAX_PRODUCT_ID characters will    *'
'*             be logged for the product ID. Larger strings         *'
'*             will be truncated.                                   *'
'*                                                                  *'
'*   char * componentID - input                                     *'
'*       Points to a null-terminated string that contains a         *'
'*       component identifier to be used on this message entry.     *'
'*       Parameter is optional, if null, no componentID is set.     *'
'*       NOTE: A maximum of CWBSV_MAX_COMP_ID characters will       *'
'*             be logged for the component ID. Larger strings       *'
'*             will be truncated.                                   *'
'*                                                                  *'
'*   cwbSV_MessageTextHandle * messageTextHandle - input/output     *'
'*       Pointer to a cwbSV_MessageTextHandle where the handle      *'
'*       will be returned. This handle should be used in            *'
'*       subsequent calls to the message text functions.            *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_NOT_ENOUGH_MEMORY - Insufficient memory to create handle.  *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   It is recommended that you set a unique product ID and         *'
'*   component ID in the message handle before using it to log      *'
'*   message text. These ID's will distinguish your messages from   *'
'*   other messages in the history log.                             *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_CreateMessageTextHandle Lib "CWBSV" ( _
                             ByVal productID As String, _
                             ByVal componentD As String, _
                             messageTextHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_CreateServiceRecHandle                                   *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function creates a service record object and returns a    *'
'*   handle to it.                                                  *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle * serviceRecHandle - input/output       *'
'*       Pointer to a cwbSV_ServiceRecordHandle where the handle    *'
'*       will be returned. This handle should be used in            *'
'*       subsequent calls to the service record functions.          *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed as handle address.           *'
'*   CWB_NOT_ENOUGH_MEMORY - Insufficient memory to create handle.  *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This handle can be used in your program to read records from   *'
'*   an open service file and extract information from the record.  *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_CreateServiceRecHandle Lib "CWBSV" ( _
                             serviceRecHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_CreateTraceAPIHandle                                     *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function creates a trace API object and returns a handle  *'
'*   to it. This trace API handle can be used in your program to    *'
'*   log entry to and exit from your API entry points.              *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   char * productID - input                                       *'
'*       Points to a null-terminated string that contains a         *'
'*       product identifier to be used on this message entry.       *'
'*       Parameter is optional, if null, no productID is set.       *'
'*       NOTE: A maximum of CWBSV_MAX_PRODUCT_ID characters will    *'
'*             be logged for the product ID. Larger strings         *'
'*             will be truncated.                                   *'
'*                                                                  *'
'*   char * componentID - input                                     *'
'*       Points to a null-terminated string that contains a         *'
'*       component identifier to be used on this message entry.     *'
'*       Parameter is optional, if null, no componentID is set.     *'
'*       NOTE: A maximum of CWBSV_MAX_COMP_ID characters will       *'
'*             be logged for the component ID. Larger strings       *'
'*             will be truncated.                                   *'
'*                                                                  *'
'*   cwbSV_TraceAPIHandle * traceAPIHandle - input/output           *'
'*       Pointer to a cwbSV_TraceAPIHandle where the handle         *'
'*       will be returned. This handle should be used in            *'
'*       subsequent calls to the trace API functions.               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_NOT_ENOUGH_MEMORY - Insufficient memory to create handle.  *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   It is recommended that you set a unique product ID and         *'
'*   component ID in the trace data handle before using it to log   *'
'*   trace entries. These ID's will distinguish your trace entries  *'
'*   from other entries in the trace file.                          *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_CreateTraceAPIHandle Lib "CWBSV" ( _
                             ByVal productID As String, _
                             ByVal componentID As String, _
                             traceAPIHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_CreateTraceDataHandle                                    *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function creates a trace data object and returns a        *'
'*   handle to it. This trace handle can be used in your program to *'
'*   log trace information to trace files. The trace information is *'
'*   supplied in a buffer passed on cwbSV_LogTraceData() calls.     *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   char * productID - input                                       *'
'*       Points to a null-terminated string that contains a         *'
'*       product identifier to be used on this message entry.       *'
'*       Parameter is optional, if null, no productID is set.       *'
'*       NOTE: A maximum of CWBSV_MAX_PRODUCT_ID characters will    *'
'*             be logged for the product ID. Larger strings         *'
'*             will be truncated.                                   *'
'*                                                                  *'
'*   char * componentID - input                                     *'
'*       Points to a null-terminated string that contains a         *'
'*       component identifier to be used on this message entry.     *'
'*       Parameter is optional, if null, no componentID is set.     *'
'*       NOTE: A maximum of CWBSV_MAX_COMP_ID characters will       *'
'*             be logged for the component ID. Larger strings       *'
'*             will be truncated.                                   *'
'*                                                                  *'
'*   cwbSV_TraceDataHandle * traceDataHandle - input/output         *'
'*       Pointer to a cwbSV_TraceDataHandle where the handle        *'
'*       will be returned. This handle should be used in            *'
'*       subsequent calls to the trace data functions.              *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_NOT_ENOUGH_MEMORY - Insufficient memory to create handle.  *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   It is recommended that you set a unique product ID and         *'
'*   component ID in the trace data handle before using it to log   *'
'*   trace entries. These ID's will distinguish your trace entries  *'
'*   from other entries in the trace file.                          *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_CreateTraceDataHandle Lib "CWBSV" ( _
                             ByVal productID As String, _
                             ByVal componentID, _
                             traceDataHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_CreateTraceSPIHandle                                     *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function creates a trace SPI object and returns a handle  *'
'*   to it. This trace SPI handle can be used in your program to    *'
'*   log entry to and exit from your SPI entry points.              *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   char * productID - input                                       *'
'*       Points to a null-terminated string that contains a         *'
'*       product identifier to be used on this message entry.       *'
'*       Parameter is optional, if null, no productID is set.       *'
'*       NOTE: A maximum of CWBSV_MAX_PRODUCT_ID characters will    *'
'*             be logged for the product ID. Larger strings         *'
'*             will be truncated.                                   *'
'*                                                                  *'
'*   char * componentID - input                                     *'
'*       Points to a null-terminated string that contains a         *'
'*       component identifier to be used on this message entry.     *'
'*       Parameter is optional, if null, no componentID is set.     *'
'*       NOTE: A maximum of CWBSV_MAX_COMP_ID characters will       *'
'*             be logged for the component ID. Larger strings       *'
'*             will be truncated.                                   *'
'*                                                                  *'
'*   cwbSV_TraceSPIHandle * traceSPIHandle - input/output           *'
'*       Pointer to a cwbSV_TraceSPIHandle where the handle         *'
'*       will be returned. This handle should be used in            *'
'*       subsequent calls to the trace SPI functions.               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_NOT_ENOUGH_MEMORY - Insufficient memory to create handle.  *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   It is recommended that you set a unique product ID and         *'
'*   component ID in the trace data handle before using it to log   *'
'*   trace entries. These ID's will distinguish your trace entries  *'
'*   from other entries in the trace file.                          *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_CreateTraceSPIHandle Lib "CWBSV" ( _
                             ByVal productID As String, _
                             ByVal componentID As String, _
                             traceSPIHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_DeleteErrHandle                                          *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function deletes the error message object that is         *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ErrHandle errorHandle - output                           *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateErrHandle() function.                          *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This call should be made when the handle is no longer needed.  *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_DeleteErrHandle Lib "CWBSV" ( _
                             errorHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_DeleteMessageTextHandle                                  *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function deletes the message text object that is          *'
'*   identified by the handle that is provided.                     *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_MessageTextHandle messageTextHandle - input              *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateMessageTextHandle() function.                  *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle passed in on request.      *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This call should be made when the handle is no longer needed.  *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_DeleteMessageTextHandle Lib "CWBSV" ( _
                             ByVal messageTextHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_DeleteServiceRecHandle                                   *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function deletes the service record object that is        *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This call should be made when the handle is no longer needed.  *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_DeleteServiceRecHandle Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_DeleteTraceAPIHandle                                     *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function deletes the trace API object that is             *'
'*   identified by the handle that is provided.                     *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_TraceAPIHandle traceAPIHandle - input                    *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateTraceAPIHandle() function.                     *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This call should be made when the handle is no longer needed.  *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_DeleteTraceAPIHandle Lib "CWBSV" ( _
                             ByVal traceAPIHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_DeleteTraceDataHandle                                    *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function deletes the trace data object that is            *'
'*   identified by the trace handle provided.                       *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_TraceDataHandle traceDataHandle - input                  *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateTraceDataHandle() function.                    *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This call should be made when the handle is no longer needed.  *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_DeleteTraceDataHandle Lib "CWBSV" ( _
                             ByVal traceDataHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_DeleteTraceSPIHandle                                     *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function deletes the trace SPI object that is             *'
'*   identified by the handle that is provided.                     *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_TraceSPIHandle traceSPIHandle - input                    *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateTraceSPIHandle() function.                     *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This call should be made when the handle is no longer needed.  *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_DeleteTraceSPIHandle Lib "CWBSV" ( _
                             ByVal traceSPIHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetComponent                                             *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the component ID value for the service record object   *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle function.                     *'
'*                                                                  *'
'*   char * componentID - input/output                              *'
'*       Pointer to a buffer that will receive the component ID     *'
'*       stored in the record identified by the handle.             *'
'*                                                                  *'
'*   unsigned long componentIDLength - input                        *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*       NOTE: The recommended size is CWBSV_MAX_COMP_ID.           *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parm               *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   The service record handle needs to be filled in by a call to   *'
'*   a "read" function before calling this routine, otherwise a     *'
'*   NULL string will be returned.                                  *'
'*                                                                  *'
'*   This function is valid for all service record types.           *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetComponent Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal componentIDchar As String, _
                             componentID As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetCreatedBy                                             *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the created by indicator for the service record object *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   cwbSV_CreatedBy * createdBy       - input/output               *'
'*      Pointer to a cwbSV_CreatedBy where the created by indicator *'
'*      will be returned.                                           *'
'*           - CWBSV_OWNER_CLIENTACCESS                             *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_PROBLEM_REC.     *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_PROBLEM_REC, a return code of  *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetCreatedBy Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             createdBy As String) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetCurrentFix                                            *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the current fix level string for the service record    *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   char * currentFix - input/output                               *'
'*       Pointer to a buffer that will receive the current fix      *'
'*       level string stored in the record identified by the handle.*'
'*                                                                  *'
'*   unsigned long currentFixLength - input                         *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*       NOTE: The recommended size is CWBSV_MAX_CURRENT_FIX.       *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_PROBLEM_REC.     *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_PROBLEM_REC, a return code of  *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetCurrentFix Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal currentFix As String, _
                             ByVal currentFixLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetDateStamp                                             *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the datestamp (in localized format) for the service    *'
'*   record identified by the handle provided.                      *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle function.                     *'
'*                                                                  *'
'*   char * dateStamp - input/output                                *'
'*       Pointer to a buffer that will receive the datestamp        *'
'*       stored in the record identified by the handle.             *'
'*                                                                  *'
'*   unsigned long dateStampLength - input                          *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*       NOTE: The recommended size is CWBSV_MAX_DATE_VALUE.        *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   The service record handle needs to be filled in by a call to   *'
'*   a "read" function before calling this routine, otherwise a     *'
'*   NULL string will be returned.                                  *'
'*                                                                  *'
'*   This function is valid for all service record types.           *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetDateStamp Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal dateStamp As String, _
                             ByVal dateStampLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetErrClass                                              *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the message class associated with the top-level        *'
'*   (e.g. most recent) error identified by the error handle        *'
'*   provided.                                                      *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ErrHandle errorHandle - input                            *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateErrHandle() function.                          *'
'*                                                                  *'
'*   unsigned long * errorClass - output                            *'
'*       Pointer to a variable that will receive the error class    *'
'*       stored in the error identified by the handle.              *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_NO_ERROR_MESSAGES - No error messages associated with    *'
'*                             error handle.                        *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetErrClass Lib "CWBSV" ( _
                             ByVal errorHandle As Long, _
                             errorClass As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetErrClassIndexed                                       *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the message class associated with the error index      *'
'*   provided. An index value of 1 will retrieve the lowest-level   *'
'*   (e.g. oldest) message associated with the error handle. An     *'
'*   index value of "cwbSV_GetErrCount()'s returned errorCount"     *'
'*   will retrieve the the top-level (e.g. most recent) message     *'
'*   associated with the error handle.                              *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ErrHandle errorHandle - input                            *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateErrHandle() function.                          *'
'*                                                                  *'
'*   unsigned long errorIndex - input                               *'
'*       Index value indicating which error text to return if       *'
'*       multiple errors are associated with the error handle.      *'
'*                                                                  *'
'*   unsigned long * errorClass - output                            *'
'*       Pointer to a variable that will receive the error class    *'
'*       stored in the error identified by the index.               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_NO_ERROR_MESSAGES - No error messages associated with    *'
'*                             error handle.                        *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   Valid index values are from 1 to cwbSV_GetErrCount()'s         *'
'*   return value. Index values less than 1  act as if 1 was        *'
'*   passed. Index values greater than cwbSV_GetErrCount() act      *'
'*   as if errorCount was passed.                                   *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetErrClassIndexed Lib "CWBSV" ( _
                             ByVal errorHandle As Long, _
                             ByVal errorIndex As Long, _
                             errorClass As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetErrCount                                              *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the number of messages associated with the error       *'
'*   handle provided.                                               *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ErrHandle errorHandle - input                            *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateErrHandle() function.                          *'
'*                                                                  *'
'*   unsigned long * errorCount - input/output                      *'
'*       Pointer to variable that receives the number of messages   *'
'*       associated with this error handle. If zero is returned,    *'
'*       no errors are associated with the error handle.            *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetErrCount Lib "CWBSV" ( _
                             ByVal errorHandle As Long, _
                             errorCount As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetErrText                                               *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the message text associated with the top-level         *'
'*   (e.g. most recent) error identified by the error handle        *'
'*   provided.                                                      *'
'*                                                                  *'
'* Parameters:                                                    *'
'*   cwbSV_ErrHandle errorHandle - input                            *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateErrHandle() function.                          *'
'*                                                                  *'
'*   char * errorText - input/output                                *'
'*       Pointer to a buffer that will receive the error message    *'
'*       text stored in the error identified by the handle.         *'
'*                                                                  *'
'*   unsigned long errorTextLength - input                          *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_NO_ERROR_MESSAGES - No error messages associated with    *'
'*                             error handle.                        *'
'* Usage Notes:                                                     *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetErrText Lib "CWBSV" ( _
                             ByVal errorHandle As Long, _
                             ByVal errorText As String, _
                             ByVal errorTextLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetErrTextIndexed                                        *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the message text associated with the error index       *'
'*   provided. An index value of 1 will retrieve the lowest-level   *'
'*   (e.g. oldest) message associated with the error handle. An     *'
'*   index value of "cwbSV_GetErrCount()'s returned errorCount"     *'
'*   will retrieve the the top-level (e.g. most recent) message     *'
'*   associated with the error handle.                              *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ErrHandle errorHandle - input                            *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateErrHandle() function.                          *'
'*                                                                  *'
'*   unsigned long errorIndex - input                               *'
'*       Index value indicating which error text to return if       *'
'*       multiple errors are associated with the error handle.      *'
'*                                                                  *'
'*   char * errorText - input/output                                *'
'*       Pointer to a buffer that will receive the error message    *'
'*       text stored in the error identified by the index.          *'
'*                                                                  *'
'*   unsigned long errorTextLength - input                          *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_NO_ERROR_MESSAGES - No error messages associated with    *'
'*                             error handle.                        *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   Valid index values are from 1 to cwbSV_GetErrCount()'s         *'
'*   return value. Index values less than 1  act as if 1 was        *'
'*   passed. Index values greater than cwbSV_GetErrCount() act      *'
'*   as if errorCount was passed.                                   *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetErrTextIndexed Lib "CWBSV" ( _
                             ByVal errorHandle As Long, _
                             ByVal errorIndex As Long, _
                             ByVal errorText As String, _
                             ByVal errorTextLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetFailMethod                                            *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the name of failing method or routine for the service  *'
'*   record identified by the handle provided.                      *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   char * failMethod - input/output                               *'
'*       Pointer to a buffer that will receive the name of the      *'
'*       failing method stored in the record identified by the      *'
'*       handle.                                                    *'
'*                                                                  *'
'*   unsigned long failMethodLength - input                         *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*       NOTE: The recommended size is CWBSV_MAX_FAIL_METHOD.       *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_PROBLEM_REC.     *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_PROBLEM_REC, a return code of  *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetFailMethod Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal failMethod As String, _
                             ByVal failMethodLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetFailModule                                            *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the name of failing module for the service record      *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   char * failModule - input/output                               *'
'*       Pointer to a buffer that will receive the name of the      *'
'*       failing module stored in the record identified by the      *'
'*       handle.                                                    *'
'*                                                                  *'
'*   unsigned long failModuleLength - input                         *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*       NOTE: The recommended size is CWBSV_MAX_FAIL_MODULE.       *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_PROBLEM_REC.     *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_PROBLEM_REC, a return code of  *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetFailModule Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal failModule As String, _
                             ByVal failModuleLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetFailPathName                                          *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the path of failing component for the service record   *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   char * pathName - input/output                                 *'
'*       Pointer to a buffer that will receive the path of the      *'
'*       failing component stored in the record identified by the   *'
'*       handle.                                                    *'
'*                                                                  *'
'*   unsigned long pathNameLength - input                           *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*       NOTE: The recommended size is CWBSV_MAX_FAIL_PATH.         *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_PROBLEM_REC.     *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_PROBLEM_REC, a return code of  *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetFailPathName Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal failPath As String, _
                             ByVal failPathLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetFailProductID                                         *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the failing product ID string for the service record   *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   char * failProductID - input/output                            *'
'*       Pointer to a buffer that will receive the product ID       *'
'*       string of the failing component stored in the record       *'
'*       identified by the handle.                                  *'
'*                                                                  *'
'*   unsigned long failProductIDLength - input                      *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*       NOTE: The recommended size is CWBSV_MAX_FAIL_PRODUCT_ID.   *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_PROBLEM_REC.     *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_PROBLEM_REC, a return code of  *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetFailProductID Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal failProductID As String, _
                             ByVal failProductIDLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetFailVersion                                           *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the failing version string for the service record      *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   char * failVersion - input/output                              *'
'*       Pointer to a buffer that will receive the version string   *'
'*       of the failing component stored in the record identified   *'
'*       by the handle.                                             *'
'*                                                                  *'
'*   unsigned long failVersionLength - input                        *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*       NOTE: The recommended size is CWBSV_MAX_FAIL_VERSION.      *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_PROBLEM_REC.     *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_PROBLEM_REC, a return code of  *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetFailVersion Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal failVersion As String, _
                             ByVal failVersionLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetMaxRecordSize                                         *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the size (in bytes) of the largest record in the       *'
'*   service file identified by the file handle provided.           *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceFileHandle serviceFileHandle - input              *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_OpenServiceFile function.                            *'
'*                                                                  *'
'*   unsigned long * recordCount - input/output                     *'
'*       Pointer to variable that receives the size of the          *'
'*       largest record in the file.                                *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetMaxRecordSize Lib "CWBSV" ( _
                             ByVal serviceFile As Long, _
                             maxRecordSize As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetMessageText                                           *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the message text portion of the service record object  *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle function.                     *'
'*                                                                  *'
'*   char * messageText - input/output                              *'
'*       Pointer to a buffer that will receive the message text     *'
'*       stored in the record identified by the handle.             *'
'*                                                                  *'
'*   unsigned long messageTextLength - input                        *'
'*       Length of the receive buffer passed in. If the buffer      *'
'*       is too small, the value will be truncated and              *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output data if the      *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parm               *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_MESSAGE_REC.     *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_MESSAGE_REC, a return code of  *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetMessageText Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal messageText As String, _
                             ByVal messageTextLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetOriginSystemID                                        *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the origin system ID string for the service record     *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   char * originSystemID - input/output                           *'
'*       Pointer to a buffer that will receive the origin system ID *'
'*       stored in the record identified by the handle.             *'
'*                                                                  *'
'*   unsigned long originSystemIDLength - input                     *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*       NOTE: The recommended size is CWBSV_MAX_ORIGIN_SYS_ID.     *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated  *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_PROBLEM_REC.     *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_PROBLEM_REC, a return code of  *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetOriginSystemID Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal originSystemID As String, _
                             ByVal originSystemIDLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetOriginSystemIPAddr                                    *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the origin system IP address for the service record    *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   char * originIPAddr - input/output                             *'
'*       Pointer to a buffer that will receive the origin system IP *'
'*       address stored in the record identified by the handle.     *'
'*                                                                  *'
'*   unsigned long originIPAddrLength - input                       *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*       NOTE: The recommended size is CWBSV_MAX_ORIGIN_IP_ADDR.    *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_PROBLEM_REC.     *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_PROBLEM_REC, a return code of  *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetOriginSystemIPAddr Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal originIPAddr As String, _
                             ByVal originIPAddrLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetPreviousFix                                           *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the previous fix level string for the service record   *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   char * previousFix - input/output                              *'
'*       Pointer to a buffer that will receive the previous fix     *'
'*       level string stored in the record identified by the handle.*'
'*                                                                  *'
'*   unsigned long previousFixLength - input                        *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*       NOTE: The recommended size is CWBSV_MAX_PREVIOUS_FIX.      *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_PROBLEM_REC.     *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_PROBLEM_REC, a return code of  *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetPreviousFix Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal previousFix As String, _
                             ByVal previousFixLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetProblemID                                             *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the problem string value for the service record object *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   char * problemID - input/output                                *'
'*       Pointer to a buffer that will receive the problem ID       *'
'*       stored in the record identified by the handle.             *'
'*                                                                  *'
'*   unsigned long problemIDLength - input                          *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*       NOTE: The recommended size is CWBSV_MAX_PROBLEM_ID.        *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_PROBLEM_REC.     *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_PROBLEM_REC, a return code of  *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetProblemID Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal problemID As String, _
                             ByVal problemIDLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetProblemStatus                                         *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the problem status for the service record object       *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   cwbSV_ProblemStatus * problemStatus - input/output             *'
'*       Pointer to a cwbSV_ProblemStatus where the problem status  *'
'*       will be returned.                                          *'
'*           - CWBSV_STATUS_READY                                   *'
'*           - CWBSV_STATUS_SENT                                    *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_PROBLEM_REC.     *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_PROBLEM_REC, a return code of  *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetProblemStatus Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             problemStatus As String) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetProblemText                                           *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the problem text string for the service record object  *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   char * problemText - input/output                              *'
'*       Pointer to a buffer that will receive the problem text     *'
'*       stored in the record identified by the handle.             *'
'*                                                                  *'
'*   unsigned long problemTextLength - input                        *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*       NOTE: The recommended size is CWBSV_MAX_PROBLEM_TEXT.      *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_PROBLEM_REC.     *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_PROBLEM_REC, a return code of  *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetProblemText Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal problemText As String, _
                             ByVal problemTextLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetProblemType                                           *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the problem type for the service record object         *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle function.                     *'
'*                                                                  *'
'*   cwbSV_ProblemType * problemType   - input/output               *'
'*       Pointer to a cwbSV_ProblemType where the problem type      *'
'*       will be returned.                                          *'
'*           - CWBSV_APP_DETECTED                                   *'
'*           - CWBSV_USER_DETECTED                                  *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_PROBLEM_REC.     *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_PROBLEM_REC, a return code of  *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetProblemType Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             problemType As Long) As Integer

'********************************************************************'
'* API:                                                             *'
'*   cwbSV_GetProduct                                               *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the product ID value for the service record object     *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle function.                     *'
'*                                                                  *'
'*   char * productID - input/output                                *'
'*       Pointer to a buffer that will receive the product ID       *'
'*       stored in the record identified by the handle.             *'
'*                                                                  *'
'*   unsigned long productIDLength - input                          *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*       NOTE: The recommended size is CWBSV_MAX_PRODUCT_ID.        *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE  - Invalid handle.                          *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   The service record handle needs to be filled in by a call to   *'
'*   a "read" function before calling this routine, otherwise a     *'
'*   NULL string will be returned.                                  *'
'*                                                                  *'
'*   This function is valid for all service record types.           *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetProduct Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal productID As String, _
                             ByVal productIDLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetRecordCount                                           *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the total numbers of records in the service file       *'
'*   identified by the file handle provided.                        *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceFileHandle serviceFileHandle - input              *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_OpenServiceFile function.                            *'
'*                                                                  *'
'*   unsigned long * recordCount - input/output                     *'
'*       Pointer to variable that receives the total number of      *'
'*       records in the file.                                       *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetRecordCount Lib "CWBSV" ( _
                             ByVal serviceFile As Long, _
                             recordCount As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetServiceFileName                                       *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the fully-qualified path and file name of where        *'
'*   the service records are being logged to for a particular       *'
'*   file type.                                                     *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceFileType serviceFileType - input                  *'
'*      Value indicating which service file name you want returned. *'
'*        - CWBSV_HISTORY_LOG                                       *'
'*        - CWBSV_PROBLEM_LOG                                       *'
'*        - CWBSV_DETAIL_TRACE_FILE                                 *'
'*        - CWBSV_ENTRY_EXIT_TRACE_FILE                             *'
'*                                                                  *'
'*   char * fileName - input/output                                 *'
'*       Pointer to a buffer that will receive the service file     *'
'*       name associated with the one requested.                    *'
'*                                                                  *'
'*   unsigned long fileNameLength - input                           *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*       NOTE: The recommended size is CWBSV_MAX_FILE_PATH.         *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWBSV_INVALID_FILE_TYPE - Invalid file type passed-in.         *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   The filename string returned could be used as input to the     *'
'*   cwbSV_OpenServiceFile() routine.                               *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetServiceFileName Lib "CWBSV" ( _
                             ByVal serviceFileType As Long, _
                             ByVal fileName As String, _
                             ByVal fileNameLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetServiceType                                           *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the type of record (trace, message, entry/exit, etc..) *'
'*   for the service record identified by the handle provided.      *'
'*                                                                  *'
'*   Note: The service record needs to be filled in by a call to    *'
'*         a "read" function before calling this function.          *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle function.                     *'
'*                                                                  *'
'*   cwbSV_ServiceRecType * serviceType - output                    *'
'*       Pointer to a cwbSV_ServiceRecType where the serviceType    *'
'*       will be returned.                                          *'
'*           - CWBSV_MESSAGE_REC                                    *'
'*           - CWBSV_PROBLEM_REC                                    *'
'*           - CWBSV_DATA_TRACE_REC                                 *'
'*           - CWBSV_API_TRACE_REC                                  *'
'*           - CWBSV_SPI_TRACE_REC                                  *'
'*                                                                  *'
'*   cwbSV_ErrHandle errorHandle - output                           *'
'*     Any returned messages will be written to this object.  It    *'
'*     is created with the cwbSV_CreateErrHandle API.  The          *'
'*     messages may be retrieved through the cwbSV_GetErrText API.  *'
'*     If the parameter is set to zero, no messages will be         *'
'*     retrieved.                                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Invalid record type detected.      *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   The service record handle needs to be filled in by a call to   *'
'*   a "read" function before calling this routine, otherwise       *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetServiceType Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             serviceType As Long, _
                             errorHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetSeverity                                              *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the problem severity for the service record object     *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   cwbSV_ProblemSeverity * severity   - output                    *'
'*       Pointer to a cwbSV_ProblemSeverity where the severity      *'
'*       will be returned.                                          *'
'*           - CWBSV_SEV_HIGH                                       *'
'*           - CWBSV_SEV_MEDIUM                                     *'
'*           - CWBSV_SEV_LOW                                        *'
'*           - CWBSV_SEV_NONE                                       *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_PROBLEM_REC.     *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_PROBLEM_REC, a return code of  *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetSeverity Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             severity As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetSymptomString                                         *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the symptom string for the service record identified   *'
'*   by the handle provided.                                        *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   char * symptomString - input/output                            *'
'*       Pointer to a buffer that will receive the symptom string   *'
'*       stored in the record identified by the handle.             *'
'*                                                                  *'
'*   unsigned long symptomStringLength - input                      *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*       NOTE: The recommended size is CWBSV_MAX_SYMPTOM_STRING.    *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_PROBLEM_REC.     *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_PROBLEM_REC, a return code of  *'
'*   CWBSV_INVALID_RECORD_TYPE will be returned.                    *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetSymptomString Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal symptomString As String, _
                             ByVal symptomStringLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetTimeStamp                                             *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the timestamp (in localized format) for the service    *'
'*   record identified by the handle provided.                      *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle function.                     *'
'*                                                                  *'
'*   char * timeStamp - input/output                                *'
'*       Pointer to a buffer that will receive the timestamp        *'
'*       stored in the record identified by the handle.             *'
'*                                                                  *'
'*   unsigned long timeStampLength - input                          *'
'*       Length of the receive buffer passed in. It should          *'
'*       include space for the terminating null character. If the   *'
'*       buffer is too small, the value will be truncated and       *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*       NOTE: The recommended size is CWBSV_MAX_TIME_VALUE.        *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output string if the    *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   The service record handle needs to be filled in by a call to   *'
'*   a "read" function before calling this routine, otherwise a     *'
'*   NULL string will be returned.                                  *'
'*                                                                  *'
'*   This function is valid for all service record types.           *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetTimeStamp Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal timeStamp As String, _
                             ByVal timeStampLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetTraceAPIData                                          *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the API trace data portion of the service record       *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   char * apiData - input/output                                  *'
'*       Pointer to a buffer that will receive the API trace data   *'
'*       stored in the record identified by the handle.             *'
'*                                                                  *'
'*       Note: The data returned is binary, hence it is NOT         *'
'*             returned as an ASCIIZ string.                        *'
'*                                                                  *'
'*   unsigned long apiDataLength - input                            *'
'*       Length of the receive buffer passed in. If the buffer      *'
'*       is too small, the value will be truncated and              *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output data if the      *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output paraemter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_API_TRACE_REC.   *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_API_TRACE_REC, a return code   *'
'*   of CWBSV_INVALID_RECORD_TYPE will be returned.                 *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetTraceAPIData Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal apiData As String, _
                             ByVal apiDataLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetTraceAPIID                                            *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the API event ID of the service record object          *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   char * apiID - input/output                                    *'
'*       Pointer to one-byte field that receives the API event ID.  *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_API_TRACE_REC.   *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_API_TRACE_REC, a return code   *'
'*   of CWBSV_INVALID_RECORD_TYPE will be returned.                 *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetTraceAPIID Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal apiID As String) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetTraceAPIType                                          *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the API event type of the service record object        *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   cwbSV_EventType * eventType - output                           *'
'*       Pointer to a cwbSV_EventType where the eventType           *'
'*       will be returned.                                          *'
'*           - CWBSV_ENTRY_POINT                                    *'
'*           - CWBSV_EXIT_POINT                                     *'
'*                                                                  *'
'*   cwbSV_ErrHandle errorHandle - output                           *'
'*     Any returned messages will be written to this object.  It    *'
'*     is created with the cwbSV_CreateErrHandle API.  The          *'
'*     messages may be retrieved through the cwbSV_GetErrText API.  *'
'*     If the parameter is set to zero, no messages will be         *'
'*     retrieved.                                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_API_TRACE_REC.   *'
'*   CWBSV_INVALID_EVENT_TYPE - Invalid event type detected.        *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_API_TRACE_REC, a return code   *'
'*   of CWBSV_INVALID_RECORD_TYPE will be returned.                 *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetTraceAPIType Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             eventType As Long, _
                             errorHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetTraceData                                             *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the trace data portion of the service record object    *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   char * traceData - input/output                                *'
'*       Pointer to a buffer that will receive the trace data       *'
'*       stored in the record identified by the handle.             *'
'*                                                                  *'
'*       Note: The data returned is binary, hence it is NOT         *'
'*             returned as an ASCIIZ string.                        *'
'*                                                                  *'
'*   unsigned long traceDataLength - input                          *'
'*       Length of the receive buffer passed in. If the buffer      *'
'*       is too small, the value will be truncated and              *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output data if the      *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_DATA_TRACE_REC.  *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_TRACE_DATA_REC, a return code  *'
'*   of CWBSV_INVALID_RECORD_TYPE will be returned.                 *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetTraceData Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal traceData As String, _
                             ByVal traceDataLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetTraceSPIData                                          *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the SPI trace data portion of the service record       *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   char * spiData - input/output                                  *'
'*       Pointer to a buffer that will receive the SPI trace data   *'
'*       stored in the record identified by the handle.             *'
'*                                                                  *'
'*       Note: The data returned is binary, hence it is NOT         *'
'*             returned as an ASCIIZ string.                        *'
'*                                                                  *'
'*   unsigned long spiDataLength - input                            *'
'*       Length of the receive buffer passed in. If the buffer      *'
'*       is too small, the value will be truncated and              *'
'*       CWB_BUFFER_OVERFLOW and returnLength will be set.          *'
'*                                                                  *'
'*   unsigned long * returnLength - input/output                    *'
'*       Optional, may be NULL. A return address to store the       *'
'*       number of bytes needed to hold the output data if the      *'
'*       receive buffer is too small.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_BUFFER_OVERFLOW - Output buffer too small, data truncated. *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_SPI_TRACE_REC.   *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_SPI_TRACE_REC, a return code   *'
'*   of CWBSV_INVALID_RECORD_TYPE will be returned.                 *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetTraceSPIData Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal spiData As String, _
                             ByVal spiDataLength As Long, _
                             returnLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetTraceSPIID                                            *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the SPI event ID of the service record object          *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   char * spiID - input/output                                    *'
'*       Pointer to one-byte field that receives the SPI event ID.  *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE  - Invalid handle.                          *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_SPI_TRACE_REC.   *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_SPI_TRACE_REC, a return code   *'
'*   of CWBSV_INVALID_RECORD_TYPE will be returned.                 *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetTraceSPIID Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             ByVal spiID As String) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_GetTraceSPIType                                          *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Returns the SPI event type of the service record object        *'
'*   identified by the handle provided.                             *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle() function.                   *'
'*                                                                  *'
'*   cwbSV_EventType * eventType - output                           *'
'*       Pointer to a cwbSV_EventType where the eventType           *'
'*       will be returned.                                          *'
'*           - CWBSV_ENTRY_POINT                                    *'
'*           - CWBSV_EXIT_POINT                                     *'
'*                                                                  *'
'*   cwbSV_ErrHandle errorHandle - output                           *'
'*     Any returned messages will be written to this object.  It    *'
'*     is created with the cwbSV_CreateErrHandle API.  The          *'
'*     messages may be retrieved through the cwbSV_GetErrText API.  *'
'*     If the parameter is set to zero, no messages will be         *'
'*     retrieved.                                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed on output parameter.         *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*   CWBSV_INVALID_RECORD_TYPE - Type is not CWBSV_SPI_TRACE_REC.   *'
'*   CWBSV_INVALID_EVENT_TYPE - Invalid event type detected.        *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   If the record type is not CWBSV_SPI_TRACE_REC, a return code   *'
'*   of CWBSV_INVALID_RECORD_TYPE will be returned.                 *'
'*   (note: cwbSV_GetServiceType() returns the current record type) *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_GetTraceSPIType Lib "CWBSV" ( _
                             ByVal serviceRecHandle As Long, _
                             eventType As Long, _
                             errorHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_LogAPIEntry                                              *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function will log an API entry point to the currently     *'
'*   active entry/exit trace file. The product and component ID's   *'
'*   set in the entry will be written along with the date and time  *'
'*   of the when the data was logged. The apiID along with any      *'
'*   optional data passed on the request will also be logged.       *'
'*                                                                  *'
'* Parameters:                                                      *'
'*                                                                  *'
'*   cwbSV_TraceAPIHandle traceAPIHandle - input                    *'
'*       Handle that was returned by a previous call to             *'
'*       cwbSV_CreateTraceAPIHandle().                              *'
'*                                                                  *'
'*   unsigned char apiID - input                                    *'
'*       A unique one-character code that will distinguish this     *'
'*       API trace point from others logged by your program.        *'
'*       Definition of these codes are left up to the caller of     *'
'*       this API. The recommended approach is to use the defined   *'
'*       range (0x00 - 0xFF) for each unique component in your      *'
'*       product (i.e. start at 0x00 for each component)            *'
'*                                                                  *'
'*   char * apiData - input                                         *'
'*       Points to a buffer that contains additional data           *'
'*       (e.g. input parameter values from your caller) that        *'
'*       you want to log along with this entry point.               *'
'*       Parameter is optional, it is ignored if the address is     *'
'*       NULL or the data length is zero. This buffer can           *'
'*       contain binary data because the length parameter is        *'
'*       used in determining the amount to trace.                   *'
'*                                                                  *'
'*   unsigned long apiDataLength - input                            *'
'*       Specifies the number of bytes in the API data buffer       *'
'*       to log for this trace entry.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This call should allows be used in conjunction with a          *'
'*   corresponding "cwbSV_LogAPIExit()". It is recommended that     *'
'*   these calls would be put at the beginning and end of an API    *'
'*   routine that you write. The other method would be to use these *'
'*   log functions around calls to external routines not written    *'
'*   by you.                                                        *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_LogAPIEntry Lib "CWBSV" ( _
                             ByVal traceAPIHandle As Long, _
                             ByVal apiID As String, _
                             ByVal apiData As Long, _
                             ByVal apiDataLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_LogAPIExit                                               *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function will log an API exit point to the currently      *'
'*   active entry/exit trace file. The product and component ID's   *'
'*   set in the entry will be written along with the date and time  *'
'*   of the when the data was logged. The API ID along with any     *'
'*   optional data passed on the request will also be logged.       *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_TraceAPIHandle traceAPIHandle - input                    *'
'*       Handle that was returned by a previous call to             *'
'*       cwbSV_CreateTraceAPIHandle().                              *'
'*                                                                  *'
'*   unsigned char apiID - input                                    *'
'*       A unique one-character code that will distinguish this     *'
'*       API trace point from others logged by your program.        *'
'*       Definition of these codes are left up to the caller of     *'
'*       this API. The recommended approach is to use the defined   *'
'*       range (0x00 - 0xFF) for each unique component in your      *'
'*       product (i.e. start at 0x00 for each component)            *'
'*                                                                  *'
'*   char * apiData - input                                         *'
'*       Points to a buffer that contains additional data           *'
'*       (e.g. output parameter values passed back to your caller)  *'
'*       that you want to log along with this exit point.           *'
'*       Parameter is optional, it is ignored if the address is     *'
'*       NULL or the data length is zero. This buffer can           *'
'*       contain binary data because the length parameter is        *'
'*       used in determining the amount to trace.                   *'
'*                                                                  *'
'*   unsigned long apiDataLength - input                            *'
'*       Specifies the number of bytes in the API data buffer       *'
'*       to log for this trace entry.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This call should allows be used in conjunction with a          *'
'*   corresponding "cwbSV_LogAPIEntry()". It is recommended that    *'
'*   these calls would be put at the beginning and end of an API    *'
'*   routine that you write. The other method would be to use these *'
'*   log functions around calls to external routines not written    *'
'*   by you.                                                        *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_LogAPIExit Lib "CWBSV" ( _
                             ByVal traceAPIHandle As Long, _
                             ByVal apiID As String, _
                             ByVal apiData As String, _
                             ByVal apiDataLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_LogMessageText                                           *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function will log the supplied message text to the        *'
'*   currently active history log. The product and component ID's   *'
'*   set in the entry will be written along with the date and time  *'
'*   of the when the text was logged.                               *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_MessageTextHandle messageTextHandle - input              *'
'*       Handle that was returned by a previous call to             *'
'*       cwbSV_CreateMessageTextHandle().                           *'
'*                                                                  *'
'*   char *  messageText - input                                    *'
'*       Points to a buffer that contains the message text you      *'
'*       want to log.                                               *'
'*                                                                  *'
'*   unsigned long messageTextLength - input                        *'
'*       Specifies the number of bytes in the message text buffer   *'
'*       to log for this message entry.                             *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle passed in on request.      *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_LogMessageText Lib "CWBSV" ( _
                             ByVal messageTextHandle As Long, _
                             ByVal messageText As String, _
                             ByVal messageTextLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_LogSPIEntry                                              *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function will log an SPI entry point to the currently     *'
'*   active entry/exit trace file. The product and component ID's   *'
'*   set in the entry will be written along with the date and time  *'
'*   of the when the data was logged. The spiID along with any      *'
'*   optional data passed on the request will also be logged.       *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_TraceSPIHandle traceSPIHandle - input                    *'
'*       Handle that was returned by a previous call to             *'
'*       cwbSV_CreateTraceSPIHandle().                              *'
'*                                                                  *'
'*   unsigned char spiID - input                                    *'
'*       A unique one-character code that will distinguish this     *'
'*       SPI trace point from others logged by your program.        *'
'*       Definition of these codes are left up to the caller of     *'
'*       this API. The recommended approach is to use the defined   *'
'*       range (0x00 - 0xFF) for each unique component in your      *'
'*       product (i.e. start at 0x00 for each component)            *'
'*                                                                  *'
'*   char * spiData - input                                         *'
'*       Points to a buffer that contains additional data           *'
'*       (e.g. input parameter values from your caller) that        *'
'*       you want to log along with this entry point.               *'
'*       Parameter is optional, it is ignored if the address is     *'
'*       NULL or the data length is zero. This buffer can           *'
'*       contain binary data because the length parameter is        *'
'*       used in determining the amount to trace.                   *'
'*                                                                  *'
'*   unsigned long  spiDataLength - input                           *'
'*       Specifies the number of bytes in the SPI data buffer       *'
'*       to log for this trace entry.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This call should allows be used in conjunction with a          *'
'*   corresponding "cwbSV_LogSPIExit()". It is recommended that     *'
'*   these calls would be put at the beginning and end of an API    *'
'*   routine that you write. The other method would be to use these *'
'*   log functions around calls to external routines not written    *'
'*   by you.                                                        *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_LogSPIEntry Lib "CWBSV" ( _
                             ByVal traceSPIHandle As Long, _
                             ByVal spiID As String, _
                             ByVal spiData As String, _
                             ByVal spiDataLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_LogSPIExit                                               *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function will log an SPI exit point to the currently      *'
'*   active entry/exit trace file. The product and component ID's   *'
'*   set in the entry will be written along with the date and time  *'
'*   of the when the data was logged. The spiID along with any      *'
'*   optional data passed on the request will also be logged.       *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_TraceSPIHandle traceSPIHandle - input                    *'
'*       Handle that was returned by a previous call to             *'
'*       cwbSV_CreateTraceSPIHandle().                              *'
'*                                                                  *'
'*   unsigned char spiID - input                                    *'
'*       A unique one-character code that will distinguish this     *'
'*       SPI trace point from others logged by your program.        *'
'*       Definition of these codes are left up to the caller of     *'
'*       this API. The recommended approach is to use the defined   *'
'*       range (0x00 - 0xFF) for each unique component in your      *'
'*       product (i.e. start at 0x00 for each component)            *'
'*                                                                  *'
'*   char * spiData - input                                         *'
'*       Points to a buffer that contains additional data           *'
'*       (e.g. output parameter values passed back to your caller)  *'
'*       that you want to log along with this exit point.           *'
'*       Parameter is optional, it is ignored if the address is     *'
'*       NULL or the data length is zero. This buffer can           *'
'*       contain binary data because the length parameter is        *'
'*       used in determining the amount to trace.                   *'
'*                                                                  *'
'*   unsigned long spiDataLength - input                            *'
'*       Specifies the number of bytes in the SPI data buffer       *'
'*       to log for this trace entry.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This call should allows be used in conjunction with a          *'
'*   corresponding "cwbSV_LogSPIEntry()". It is recommended that    *'
'*   these calls would be put at the beginning and end of an API    *'
'*   routine that you write. The other method would be to use these *'
'*   log functions around calls to external routines not written    *'
'*   by you.                                                        *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_LogSPIExit Lib "CWBSV" ( _
                       ByVal traceSPIHandle As Long, _
                       ByVal spiID As String, _
                       ByVal spiData As String, _
                       ByVal spiDataLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_LogTraceData                                             *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function will log the supplied trace data to the          *'
'*   currently active trace file. The product and component ID's    *'
'*   set in the entry will be written along with the date and time  *'
'*   of the when the data was logged.                               *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_TraceDataHandle traceDataHandle - input                  *'
'*       Handle that was returned by a previous call to             *'
'*       cwbSV_CreateTraceDataHandle().                             *'
'*                                                                  *'
'*   char * traceData - input                                       *'
'*       Points to a buffer that contains the trace data you want   *'
'*       to log. The buffer can contain binary data because the     *'
'*       length parameter is used in determining the amount to      *'
'*       trace.                                                     *'
'*                                                                  *'
'*   unsigned long traceDataLength - input                          *'
'*       Specifies the number of bytes in the trace data buffer     *'
'*       to log for this trace entry.                               *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_LogTraceData Lib "CWBSV" ( _
                             ByVal traceDataHandle As Long, _
                             ByVal traceData As String, _
                             ByVal traceDataLength As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_OpenServiceFile                                          *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Opens the specified service file for READ access (history log, *'
'*   trace file, etc..) and returns a handle to it.                 *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   char * serviceFileName - input                                 *'
'*       Points to a buffer that contains the fully-qualified       *'
'*       name (e.g. c:\path\filename.ext) of the service file       *'
'*       to open.                                                   *'
'*                                                                  *'
'*   cwbSV_ServiceFileHandle * serviceFileHandle - input/output     *'
'*       Pointer to a cwbSV_ServiceFileHandle where the handle      *'
'*       will be returned. This handle should be used in            *'
'*       subsequent calls to the service file functions.            *'
'*                                                                  *'
'*   cwbSV_ErrHandle errorHandle - output                           *'
'*     Any returned messages will be written to this object.  It    *'
'*     is created with the cwbSV_CreateErrHandle API.  The          *'
'*     messages may be retrieved through the cwbSV_GetErrText API.  *'
'*     If the parameter is set to zero, no messages will be         *'
'*     retrieved.                                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_POINTER - NULL passed as handle address.           *'
'*   CWB_FILE_IO_ERROR - File could not be opened.                  *'
'*   CWB_NOT_ENOUGH_MEMORY - Insufficient memory to create handle.  *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_OpenServiceFile Lib "CWBSV" ( _
                             ByVal serviceFileName As String, _
                             serviceFileHandle As Long, _
                             ByVal errorHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_ReadNewestRecord                                         *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Reads the newest record in the service file into the record    *'
'*   handle provided. Subsequent calls can be made to retrieve      *'
'*   the information stored in this record (e.g. GetProduct(),      *'
'*   GetDateStamp(), etc...).                                       *'
'*                                                                  *'
'*   Note: This record is the one with the newest time and          *'
'*         date stamp in the file.                                  *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceFileHandle serviceFileHandle - input              *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_OpenServiceFile function.                            *'
'*                                                                  *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle function.                     *'
'*                                                                  *'
'*   cwbSV_ErrHandle errorHandle - output                           *'
'*     Any returned messages will be written to this object.  It    *'
'*     is created with the cwbSV_CreateErrHandle API.  The          *'
'*     messages may be retrieved through the cwbSV_GetErrText API.  *'
'*     If the parameter is set to zero, no messages will be         *'
'*     retrieved.                                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_END_OF_FILE - End of file has been reached.                *'
'*   CWB_FILE_IO_ERROR - Record could not be read.                  *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This read would be used as a "priming-type" read before        *'
'*   issuing a series of cwbsv_ReadPrevRecord() calls until the     *'
'*   the end-of-file indicator is returned.                         *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_ReadNewestRecord Lib "CWBSV" ( _
                             ByVal serviceFileHandle As Long, _
                             ByVal serviceRecHandle As Long, _
                             errorHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_ReadNextRecord                                           *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Reads the next record in the service file into the record      *'
'*   handle provided. Subsequent calls can be made to retrieve      *'
'*   the information stored in this record (e.g. GetProduct(),      *'
'*   GetDateStamp(), etc...).                                       *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceFileHandle serviceFileHandle - input              *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_OpenServiceFile function.                            *'
'*                                                                  *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle function.                     *'
'*                                                                  *'
'*   cwbSV_ErrHandle errorHandle - output                           *'
'*     Any returned messages will be written to this object.  It    *'
'*     is created with the cwbSV_CreateErrHandle API.  The          *'
'*     messages may be retrieved through the cwbSV_GetErrText API.  *'
'*     If the parameter is set to zero, no messages will be         *'
'*     retrieved.                                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_END_OF_FILE - End of file has been reached.                *'
'*   CWB_FILE_IO_ERROR - Record could not be read.                  *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This read would normally be used once the priming read,        *'
'*   "ReadOldestRecord()" is performed.                             *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_ReadNextRecord Lib "CWBSV" ( _
                             ByVal serviceFileHandle As Long, _
                             ByVal serviceRecHandle As Long, _
                             errorHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_ReadOldestRecord                                         *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Reads the oldest record in the service file into the record    *'
'*   handle provided. Subsequent calls can be made to retrieve      *'
'*   the information stored in this record (e.g. GetProduct(),      *'
'*   GetDateStamp(), etc...).                                       *'
'*                                                                  *'
'*   Note: This record is the one with the oldest time and          *'
'*         date stamp in the file.                                  *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceFileHandle serviceFileHandle - input              *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_OpenServiceFile function.                            *'
'*                                                                  *'
'*   cwbSV_ServiceRecHandle serviceRecHandle - input                *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle function.                     *'
'*                                                                  *'
'*   cwbSV_ErrHandle errorHandle - output                           *'
'*     Any returned messages will be written to this object.  It    *'
'*     is created with the cwbSV_CreateErrHandle API.  The          *'
'*     messages may be retrieved through the cwbSV_GetErrText API.  *'
'*     If the parameter is set to zero, no messages will be         *'
'*     retrieved.                                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_END_OF_FILE - End of file has been reached.                *'
'*   CWB_FILE_IO_ERROR - Record could not be read.                  *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This read would be used as a "priming-type" read before        *'
'*   issuing a series of cwbsv_ReadNextRecord() calls until the     *'
'*   the end-of-file indicator is returned.                         *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_ReadOldestRecord Lib "CWBSV" ( _
                             ByVal serviceFileHandle As Long, _
                             ByVal serviceRecHandle As Long, _
                             errorHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_ReadPrevRecord                                           *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   Reads the previous record in the service file into the record  *'
'*   handle provided. Subsequent calls can be made to retrieve      *'
'*   the information stored in this record (e.g. GetProduct(),      *'
'*   GetDateStamp(), etc...).                                       *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_ServiceFileHandle serviceFileHandle - input              *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_OpenServiceFile function.                            *'
'*                                                                  *'
'*   cwbSV_ServiceRecHandle serviceRecHandle -input                 *'
'*       Handle that was returned by a previous call to the         *'
'*       cwbSV_CreateServiceRecHandle function.                     *'
'*                                                                  *'
'*   cwbSV_ErrHandle errorHandle - output                           *'
'*     Any returned messages will be written to this object.  It    *'
'*     is created with the cwbSV_CreateErrHandle API.  The          *'
'*     messages may be retrieved through the cwbSV_GetErrText API.  *'
'*     If the parameter is set to zero, no messages will be         *'
'*     retrieved.                                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_END_OF_FILE - End of file has been reached.                *'
'*   CWB_FILE_IO_ERROR - Record could not be read.                  *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This read would normally be used once the priming read,        *'
'*   "ReadNewestRecord()" is performed.                             *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_ReadPrevRecord Lib "CWBSV" ( _
                             ByVal serviceFileHandle As Long, _
                             ByVal serviceRecHandle As Long, _
                             errorHandle As Long) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_SetMessageComponent                                      *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function allows setting of a unique component identifier  *'
'*   in the message handle provided. Along with setting the         *'
'*   product ID (see cwbSV_SetMessageProduct), this call should     *'
'*   be used to distinguish your message entries from other         *'
'*   product's entries in the history log.                          *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_MessageTextHandle messageTextHandle - input              *'
'*       Handle that was returned by a previous call to             *'
'*       cwbSV_CreateMessageTextHandle().                           *'
'*                                                                  *'
'*   char * componentID - input                                     *'
'*       Points to a null-terminated string that contains a         *'
'*       component identifier to be used on this message entry.     *'
'*       NOTE: A maximum of CWBSV_MAX_COMP_ID characters will       *'
'*             be logged for the component ID. Larger strings       *'
'*             will be truncated.                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle passed in on request.      *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This value should be set before calling the corresponding      *'
'*   log function, "cwbSV_LogMessageData()".                        *'
'*   The suggested hierarchy is that you would define a product ID  *'
'*   with one or many components defined under it.                  *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_SetMessageComponent Lib "CWBSV" ( _
                             ByVal messageTextHandle As Long, _
                             ByVal componentID As String) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_SetMessageProduct                                        *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function allows setting of a unique product identifier in *'
'*   the message handle provided. Along with setting the component  *'
'*   ID (see cwbSV_SetMessageComponent), this call should be used   *'
'*   to distinguish your message entries from other product's       *'
'*   entries in the history log.                                    *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_MessageTextHandle messageTextHandle - input              *'
'*       Handle that was returned by a previous call to             *'
'*       cwbSV_CreateMessageTextHandle().                           *'
'*                                                                  *'
'*   char * productID - input                                       *'
'*       Points to a null-terminated string that contains a         *'
'*       product identifier to be used on this message entry.       *'
'*       NOTE: A maximum of CWBSV_MAX_PRODUCT_ID characters will    *'
'*             be logged for the product ID. Larger strings         *'
'*             will be truncated.                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle passed in on request.      *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This value should be set before calling the corresponding      *'
'*   log function, "cwbSV_LogMessageData()".                        *'
'*   The suggested hierarchy is that you would define a product ID  *'
'*   with one or many components defined under it.                  *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_SetMessageProduct Lib "CWBSV" ( _
                             ByVal messageTextHandle As Long, _
                             ByVal productID As String) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_SetAPIComponent                                          *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function allows setting of a unique component identifier  *'
'*   in trace entry provided. Along with setting the product        *'
'*   ID (see cwbSV_SetAPIProduct), this call should be used to      *'
'*   distinguish your trace entries from other product's entries in *'
'*   the trace file.                                                *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_TraceAPIHandle traceAPIHandle - input                    *'
'*       Handle that was returned by a previous call to             *'
'*       cwbSV_CreateTraceAPIHandle().                              *'
'*                                                                  *'
'*   char * componentID - input                                     *'
'*       Points to a null-terminated string that contains a         *'
'*       component identifier to be used on this trace entry.       *'
'*                                                                  *'
'*       NOTE: A maximum of CWBSV_MAX_COMP_ID characters will       *'
'*             be logged for the component ID. Larger strings       *'
'*             will be truncated.                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This value should be set before calling the corresponding      *'
'*   log functions, "cwbSV_LogAPIEntry()" or "cwbSV_LogAPIExit().   *'
'*   The suggested hierarchy is that you would define a product ID  *'
'*   with one or many components defined under it.                  *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_SetAPIComponent Lib "CWBSV" ( _
                             ByVal traceAPIHandle As Long, _
                             ByVal componentID As String) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_SetAPIProduct                                            *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function allows setting of a unique product identifier in *'
'*   the trace handle provided. Along with setting the component    *'
'*   ID (see cwbSV_SetAPIComponent), this call should be used to    *'
'*   distinguish your trace entries from other product's entries in *'
'*   the trace file.                                                *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_TraceAPIHandle traceAPIHandle - input                    *'
'*       Handle that was returned by a previous call to             *'
'*       cwbSV_CreateTraceAPIHandle().                              *'
'*                                                                  *'
'*   char * productID - input                                       *'
'*       Points to a null-terminated string that contains a         *'
'*       product identifier to be used on this trace entry.         *'
'*                                                                  *'
'*       NOTE: A maximum of CWBSV_MAX_PRODUCT_ID characters will    *'
'*             be logged for the product ID. Larger strings         *'
'*             will be truncated.                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This value should be set before calling the corresponding      *'
'*   log functions, "cwbSV_LogAPIEntry()" or "cwbSV_LogAPIExit().   *'
'*   The suggested hierarchy is that you would define a product ID  *'
'*   with one or many components defined under it.                  *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_SetAPIProduct Lib "CWBSV" ( _
                             ByVal traceAPIHandle As Long, _
                             ByVal productID As String) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_SetSPIComponent                                          *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function allows setting of a unique component identifier  *'
'*   in trace entry provided. Along with setting the product        *'
'*   ID (see cwbSV_SetSPIProduct), this call should be used to      *'
'*   distinguish your trace entries from other product's entries in *'
'*   the trace file.                                                *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_TraceSPIHandle traceSPIHandle - input                    *'
'*       Handle that was returned by a previous call to             *'
'*       cwbSV_CreateTraceSPIHandle().                              *'
'*                                                                  *'
'*   char * componentID - input                                     *'
'*       Points to a null-terminated string that contains a         *'
'*       component identifier to be used on this trace entry.       *'
'*                                                                  *'
'*       NOTE: A maximum of CWBSV_MAX_COMP_ID characters will       *'
'*             be logged for the component ID. Larger strings       *'
'*             will be truncated.                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This value should be set before calling the corresponding      *'
'*   log functions, "cwbSV_LogAPIEntry()" or "cwbSV_LogAPIExit().   *'
'*   The suggested hierarchy is that you would define a product ID  *'
'*   with one or many components defined under it.                  *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_SetSPIComponent Lib "CWBSV" ( _
                             ByVal traceSPIHandle As Long, _
                             ByVal componentID As String) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_SetSPIProduct                                            *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function allows setting of a unique product identifier in *'
'*   the trace handle provided. Along with setting the component    *'
'*   ID (see cwbSV_SetSPIComponent), this call should be used to    *'
'*   distinguish your trace entries from other product's entries in *'
'*   the trace file.                                                *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_TraceSPIHandle traceSPIHandle - input                    *'
'*       Handle that was returned by a previous call to             *'
'*       cwbSV_CreateTraceSPIHandle().                              *'
'*                                                                  *'
'*   char * productID - input                                       *'
'*       Points to a null-terminated string that contains a         *'
'*       product identifier to be used on this trace entry.         *'
'*                                                                  *'
'*       NOTE: A maximum of CWBSV_MAX_PRODUCT_ID characters will    *'
'*             be logged for the product ID. Larger strings         *'
'*             will be truncated.                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This value should be set before calling the corresponding      *'
'*   log functions, "cwbSV_LogAPIEntry()" or "cwbSV_LogAPIExit().   *'
'*   The suggested hierarchy is that you would define a product ID  *'
'*   with one or many components defined under it.                  *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_SetSPIProduct Lib "CWBSV" ( _
                             ByVal traceSPIHandle As Long, _
                             ByVal productID As String) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_SetTraceComponent                                        *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function allows setting of a unique component identifier  *'
'*   in service entry provided. Along with setting the product      *'
'*   ID (see cwbSV_SetTraceProduct), this call should be used to    *'
'*   distinguish your trace entries from other product's entries in *'
'*   the trace file.                                                *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_TraceDataHandle traceDataHandle - input                  *'
'*       Handle that was returned by a previous call to             *'
'*       cwbSV_CreateTraceDataHandle().                             *'
'*                                                                  *'
'*   char * componentID - input                                     *'
'*       Points to a null-terminated string that contains a         *'
'*       component identifier to be used on this trace entry.       *'
'*                                                                  *'
'*       NOTE: A maximum of CWBSV_MAX_COMP_ID characters will       *'
'*             be logged for the component ID. Larger strings       *'
'*             will be truncated.                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This value should be set before calling the corresponding      *'
'*   log function, "cwbSV_LogTraceData()".                          *'
'*   The suggested hierarchy is that you would define a product ID  *'
'*   with one or many components defined under it.                  *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_SetTraceComponent Lib "CWBSV" ( _
                             ByVal traceDataHandle As Long, _
                             ByVal componentID As String) As Integer

'********************************************************************'
'*                                                                  *'
'* API:                                                             *'
'*   cwbSV_SetTraceProduct                                          *'
'*                                                                  *'
'* Purpose:                                                         *'
'*   This function allows setting of a unique product identifier in *'
'*   the trace handle provided. Along with setting the component    *'
'*   ID (see cwbSV_SetTraceComponent), this call should be used to  *'
'*   distinguish your trace entries from other product's entries in *'
'*   the trace file.                                                *'
'*                                                                  *'
'* Parameters:                                                      *'
'*   cwbSV_TraceDataHandle traceDataHandle - input                  *'
'*       Handle that was returned by a previous call to             *'
'*       cwbSV_CreateTraceDataHandle().                             *'
'*                                                                  *'
'*   char * productID - input                                       *'
'*       Points to a null-terminated string that contains a         *'
'*       product identifier to be used on this trace entry.         *'
'*                                                                  *'
'*       NOTE: A maximum of CWBSV_MAX_PRODUCT_ID characters will    *'
'*             be logged for the product ID. Larger strings         *'
'*             will be truncated.                                   *'
'*                                                                  *'
'* Return Codes:                                                    *'
'*   The following list shows common return values.                 *'
'*                                                                  *'
'*   CWB_OK - Successful completion.                                *'
'*   CWB_INVALID_HANDLE - Invalid handle.                           *'
'*                                                                  *'
'* Usage Notes:                                                     *'
'*   This value should be set before calling the corresponding      *'
'*   log function, "cwbSV_LogTraceData()".                          *'
'*   The suggested hierarchy is that you would define a product ID  *'
'*   with one or many components defined under it.                  *'
'*                                                                  *'
'********************************************************************'
Declare Function cwbSV_SetTraceProduct Lib "CWBSV" ( _
                             ByVal traceDataHandle As Long, _
                             ByVal productID As String) As Integer


